
/*  A Bison parser, made from yabasic.bison
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	tSEP	258
#define	tEOFILE	259
#define	tFNUM	260
#define	tSYMBOL	261
#define	tSTRSYM	262
#define	tDOCU	263
#define	tDIGITS	264
#define	tSTRING	265
#define	tFOR	266
#define	tTO	267
#define	tSTEP	268
#define	tNEXT	269
#define	tWHILE	270
#define	tWEND	271
#define	tREPEAT	272
#define	tUNTIL	273
#define	tGOTO	274
#define	tGOSUB	275
#define	tLABEL	276
#define	tON	277
#define	tSUB	278
#define	tENDSUB	279
#define	tLOCAL	280
#define	tSTATIC	281
#define	tIMPORT	282
#define	tEXPORT	283
#define	tERROR	284
#define	tINTERRUPT	285
#define	tBREAK	286
#define	tCONTINUE	287
#define	tIF	288
#define	tTHEN	289
#define	tELSE	290
#define	tELSIF	291
#define	tENDIF	292
#define	tUSING	293
#define	tPRINT	294
#define	tINPUT	295
#define	tLINE	296
#define	tRETURN	297
#define	tDIM	298
#define	tEND	299
#define	tEXIT	300
#define	tAT	301
#define	tSCREEN	302
#define	tREVERSE	303
#define	tCOLOUR	304
#define	tAND	305
#define	tOR	306
#define	tNOT	307
#define	tNEQ	308
#define	tLEQ	309
#define	tGEQ	310
#define	tLTN	311
#define	tGTN	312
#define	tEQU	313
#define	tPOW	314
#define	tREAD	315
#define	tDATA	316
#define	tRESTORE	317
#define	tOPEN	318
#define	tCLOSE	319
#define	tORIGIN	320
#define	tWINDOW	321
#define	tDOT	322
#define	tCIRCLE	323
#define	tTEXT	324
#define	tCLEAR	325
#define	tPRINTER	326
#define	tWAIT	327
#define	tBELL	328
#define	tARDIM	329
#define	tARSIZE	330
#define	tBOX	331
#define	tRECT	332
#define	tGETBIT	333
#define	tPUTBIT	334
#define	tGETCHAR	335
#define	tPUTCHAR	336
#define	tFRAME	337
#define	tNEW	338
#define	tCURVE	339
#define	tSIN	340
#define	tASIN	341
#define	tCOS	342
#define	tACOS	343
#define	tTAN	344
#define	tATAN	345
#define	tEXP	346
#define	tLOG	347
#define	tSQRT	348
#define	tSQR	349
#define	tMYEOF	350
#define	tABS	351
#define	tSIG	352
#define	tINT	353
#define	tFRAC	354
#define	tMOD	355
#define	tRAN	356
#define	tLEN	357
#define	tVAL	358
#define	tLEFT	359
#define	tRIGHT	360
#define	tMID	361
#define	tMIN	362
#define	tMAX	363
#define	tSTR	364
#define	tINKEY	365
#define	tCHR	366
#define	tASC	367
#define	tHEX	368
#define	tDEC	369
#define	tUPPER	370
#define	tLOWER	371
#define	tMOUSEX	372
#define	tMOUSEY	373
#define	tMOUSEB	374
#define	tTRIM	375
#define	tLTRIM	376
#define	tRTRIM	377
#define	tINSTR	378
#define	tSYSTEM	379
#define	tSYSTEM2	380
#define	tPEEK	381
#define	tPEEK2	382
#define	tPOKE	383
#define	tDATE	384
#define	tTIME	385
#define	tTOKEN	386
#define	tSPLIT	387
#define	tGLOB	388
#define	UMINUS	389


/*

    YABASIC ---  a simple Basic Interpreter
    written by Marc-Oliver Ihm 1995-99
    homepage: www.yabasic.de

    BISON part
     
    This file is part of yabasic and may be copied only 
    under the terms of either the Artistic License or 
    the GNU General Public License (GPL), both of which 
    can be found at www.yabasic.de
 
*/

/*
  $Id: yabasic.bison,v 2.55 1999/08/13 16:46:15 ihm Exp ihm $
*/

#undef WINDOWS

#ifndef YABASIC_INCLUDED
#include "yabasic.h"     /* definitions of yabasic */
#endif

#include <malloc.h>

#if HAVE_ALLOCA_H
#include <alloca.h>
#endif

void __yy_bcopy(char *,char *,int); /* prototype missing */

int tileol; /* true, read should go to eon of line */
int yylineno=1; /* line number; counts fresh in every new file */
int main_lineno=1; /* line number of main */
int function_type=ftNONE; /* contains function type while parsing function */
char *current_function=NULL; /* name of currently parsed function */
int exported=FALSE; /* true, if function is exported */
char *due_to_import=NULL; /* library file to import next */
int yylex(void);
extern struct libfile_name *current_libfile; /*  defined in main.c: name of currently parsed file */

typedef union {
  double fnum;          /* double number */
  int inum;             /* integer number */
  int token;            /* token of command */
  int sep;              /* number of newlines */
  char *string;         /* quoted string */
  char *symbol;         /* general symbol */
  char *digits;         /* string of digits */
  char *docu;		/* embedded documentation */
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		769
#define	YYFLAG		-32768
#define	YYNTBASE	144

#define YYTRANSLATE(x) ((unsigned)(x) <= 389 ? yytranslate[x] : 231)

static const short yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,   143,     2,     2,     2,     2,   141,
   142,   136,   135,   140,   134,     2,   137,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,   139,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
   106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
   126,   127,   128,   129,   130,   131,   132,   133,   138
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     3,     5,     6,     7,    13,    14,    16,    18,    21,
    24,    26,    28,    30,    32,    34,    36,    37,    41,    42,
    46,    48,    50,    53,    56,    60,    64,    65,    71,    72,
    78,    81,    83,    86,    90,    95,   100,   101,   105,   106,
   111,   114,   117,   119,   122,   124,   127,   130,   133,   139,
   147,   151,   154,   159,   163,   172,   179,   186,   189,   194,
   199,   206,   211,   216,   221,   227,   233,   236,   239,   242,
   245,   249,   252,   255,   257,   259,   263,   268,   273,   278,
   283,   288,   293,   295,   297,   300,   302,   306,   317,   326,
   335,   339,   341,   343,   350,   355,   357,   362,   364,   366,
   368,   370,   374,   378,   385,   392,   401,   406,   413,   415,
   419,   424,   429,   434,   439,   444,   449,   454,   459,   461,
   463,   468,   475,   482,   487,   494,   499,   506,   517,   522,
   526,   530,   532,   534,   539,   544,   551,   558,   560,   564,
   566,   570,   574,   578,   582,   586,   589,   593,   598,   603,
   608,   613,   618,   623,   630,   635,   640,   645,   650,   655,
   660,   665,   670,   677,   682,   686,   693,   700,   705,   710,
   715,   720,   727,   732,   737,   742,   747,   749,   754,   756,
   761,   763,   768,   775,   777,   780,   783,   785,   787,   789,
   791,   796,   803,   808,   815,   820,   825,   826,   829,   830,
   832,   836,   838,   840,   841,   842,   843,   855,   857,   859,
   860,   862,   864,   868,   870,   872,   877,   882,   884,   888,
   890,   892,   897,   902,   903,   905,   909,   911,   913,   917,
   921,   922,   923,   924,   925,   941,   943,   945,   946,   949,
   950,   952,   953,   954,   963,   964,   972,   973,   974,   975,
   986,   987,   992,   994,   996,  1000,  1004,  1008,  1011,  1015,
  1019,  1023,  1027,  1031,  1035,  1039,  1043,  1047,  1051,  1055,
  1059,  1064,  1071,  1073,  1074,  1077,  1078,  1079,  1080,  1088,
  1090,  1091,  1096,  1098,  1103,  1105,  1110,  1112,  1116,  1118,
  1123,  1125,  1130,  1132,  1134,  1138,  1142,  1143,  1146,  1151,
  1153,  1157,  1158,  1161,  1162,  1166,  1167,  1172,  1173,  1175,
  1177,  1179,  1182,  1188,  1196,  1197,  1204,  1209,  1212,  1215,
  1217,  1219,  1221,  1225,  1227
};

static const short yyrhs[] = {   145,
     4,     0,   148,     0,     0,     0,   145,   146,     3,   147,
   148,     0,     0,   155,     0,   161,     0,    27,     6,     0,
    29,   159,     0,   187,     0,   198,     0,   195,     0,   175,
     0,   169,     0,   170,     0,     0,    25,   149,   181,     0,
     0,    26,   150,   183,     0,   200,     0,   204,     0,    19,
   167,     0,    20,   167,     0,    22,    30,    31,     0,    22,
    30,    32,     0,     0,    22,   162,    19,   151,   229,     0,
     0,    22,   162,    20,   152,   230,     0,    21,   167,     0,
   157,     0,    64,   227,     0,    39,   224,   218,     0,    39,
   224,   218,   139,     0,    39,   224,   218,   140,     0,     0,
    40,   153,   220,     0,     0,    41,    40,   154,   220,     0,
    60,   215,     0,    61,   217,     0,    62,     0,    62,   167,
     0,    42,     0,    42,   162,     0,    42,   159,     0,    43,
   168,     0,    63,    66,   162,   140,   162,     0,    63,    66,
   162,   140,   162,   140,   159,     0,    66,    65,   159,     0,
    67,   163,     0,    41,   163,   156,   163,     0,    41,   156,
   163,     0,    79,   159,   156,   162,   140,   162,   140,   159,
     0,    79,   159,   156,   162,   140,   162,     0,    81,   159,
   156,   162,   140,   162,     0,    83,    84,     0,    68,   163,
   140,   162,     0,    69,   163,   140,   159,     0,    69,   163,
   140,   159,   140,   159,     0,    76,   163,   156,   163,     0,
    82,   163,   156,   163,     0,    77,   163,   156,   163,     0,
    70,    77,   163,   156,   163,     0,    70,    76,   163,   156,
   163,     0,    64,    66,     0,    70,    66,     0,    70,    47,
     0,    63,    71,     0,    63,    71,   159,     0,    64,    71,
     0,    72,   162,     0,    73,     0,   110,     0,   110,   141,
   142,     0,   110,   141,   162,   142,     0,   125,   141,   159,
   142,     0,   128,   159,   140,   159,     0,   128,   159,   140,
   162,     0,   128,   227,   140,   159,     0,   128,   227,   140,
   162,     0,    44,     0,    45,     0,    45,   162,     0,     8,
     0,     7,    58,   159,     0,   106,   141,   158,   140,   162,
   140,   162,   142,    58,   159,     0,   104,   141,   158,   140,
   162,   142,    58,   159,     0,   105,   141,   158,   140,   162,
   142,    58,   159,     0,   170,    58,   159,     0,   140,     0,
    12,     0,    63,   227,   140,   159,   140,   159,     0,    63,
   227,   140,   159,     0,     7,     0,     7,   141,   171,   142,
     0,     7,     0,   160,     0,   170,     0,    10,     0,   159,
   135,   159,     0,   141,   159,   142,     0,   104,   141,   159,
   140,   162,   142,     0,   105,   141,   159,   140,   162,   142,
     0,   106,   141,   159,   140,   162,   140,   162,   142,     0,
   109,   141,   162,   142,     0,   109,   141,   162,   140,   159,
   142,     0,   110,     0,   110,   141,   142,     0,   110,   141,
   162,   142,     0,   111,   141,   162,   142,     0,   115,   141,
   159,   142,     0,   116,   141,   159,   142,     0,   121,   141,
   159,   142,     0,   122,   141,   159,   142,     0,   120,   141,
   159,   142,     0,   124,   141,   159,   142,     0,   129,     0,
   130,     0,   127,   141,   159,   142,     0,   127,   141,   159,
   140,   159,   142,     0,   131,   141,   158,   140,   159,   142,
     0,   131,   141,   158,   142,     0,   132,   141,   158,   140,
   159,   142,     0,   132,   141,   158,   142,     0,    78,   141,
   163,   156,   163,   142,     0,    80,   141,   162,   140,   162,
   156,   162,   140,   162,   142,     0,   113,   141,   162,   142,
     0,     6,    58,   162,     0,   169,    58,   162,     0,   166,
     0,   164,     0,    74,   141,   162,   142,     0,    74,   141,
   159,   142,     0,    75,   141,   162,   140,   162,   142,     0,
    75,   141,   159,   140,   162,   142,     0,   169,     0,   141,
   162,   142,     0,     6,     0,   162,   135,   162,     0,   162,
   134,   162,     0,   162,   136,   162,     0,   162,   137,   162,
     0,   162,    59,   162,     0,   134,   162,     0,   162,   140,
   162,     0,    85,   141,   162,   142,     0,    86,   141,   162,
   142,     0,    87,   141,   162,   142,     0,    88,   141,   162,
   142,     0,    89,   141,   162,   142,     0,    90,   141,   162,
   142,     0,    90,   141,   162,   140,   162,   142,     0,    91,
   141,   162,   142,     0,    92,   141,   162,   142,     0,    93,
   141,   162,   142,     0,    94,   141,   162,   142,     0,    98,
   141,   162,   142,     0,    99,   141,   162,   142,     0,    96,
   141,   162,   142,     0,    97,   141,   162,   142,     0,   100,
   141,   162,   140,   162,   142,     0,   101,   141,   162,   142,
     0,   101,   141,   142,     0,   107,   141,   162,   140,   162,
   142,     0,   108,   141,   162,   140,   162,   142,     0,   102,
   141,   159,   142,     0,   103,   141,   159,   142,     0,   112,
   141,   159,   142,     0,   114,   141,   159,   142,     0,   123,
   141,   159,   140,   159,   142,     0,   125,   141,   159,   142,
     0,   126,   141,   227,   142,     0,   126,   141,   159,   142,
     0,   117,   141,   159,   142,     0,   117,     0,   118,   141,
   159,   142,     0,   118,     0,   119,   141,   159,   142,     0,
   119,     0,    63,   141,   159,   142,     0,    63,   141,   159,
   140,   159,   142,     0,   166,     0,   135,   166,     0,   134,
   166,     0,     5,     0,     9,     0,     9,     0,     6,     0,
     6,   141,   171,   142,     0,   168,   140,     6,   141,   171,
   142,     0,     7,   141,   171,   142,     0,   168,   140,     7,
   141,   171,   142,     0,     6,   141,   171,   142,     0,     7,
   141,   171,   142,     0,     0,   172,   173,     0,     0,   174,
     0,   173,   140,   174,     0,   159,     0,   162,     0,     0,
     0,     0,   180,    23,   176,   179,   177,   141,   185,   142,
   178,   145,    24,     0,     6,     0,     7,     0,     0,    28,
     0,   182,     0,   181,   140,   182,     0,     6,     0,     7,
     0,     6,   141,   171,   142,     0,     7,   141,   171,   142,
     0,   184,     0,   183,   140,   184,     0,     6,     0,     7,
     0,     6,   141,   171,   142,     0,     7,   141,   171,   142,
     0,     0,   186,     0,   185,   140,   186,     0,     6,     0,
     7,     0,     6,   141,   142,     0,     7,   141,   142,     0,
     0,     0,     0,     0,    11,     6,    58,   188,   162,    12,
   162,   193,   189,     3,   190,   145,   191,   192,   194,     0,
    14,     0,     4,     0,     0,    13,   162,     0,     0,     6,
     0,     0,     0,    15,   196,   141,   207,   142,   197,   145,
    16,     0,     0,    17,   199,   145,    18,   141,   207,   142,
     0,     0,     0,     0,    33,   207,   201,    34,   145,   202,
   209,   208,   203,   206,     0,     0,    33,   207,   205,   148,
     0,    37,     0,     4,     0,   141,   207,   142,     0,   207,
    51,   207,     0,   207,    50,   207,     0,    52,   207,     0,
   159,    58,   159,     0,   159,    53,   159,     0,   159,    56,
   159,     0,   159,    54,   159,     0,   159,    57,   159,     0,
   159,    55,   159,     0,   162,    58,   162,     0,   162,    53,
   162,     0,   162,    56,   162,     0,   162,    54,   162,     0,
   162,    57,   162,     0,   162,    55,   162,     0,    95,   141,
   162,   142,     0,   133,   141,   159,   140,   159,   142,     0,
   157,     0,     0,    35,   145,     0,     0,     0,     0,    36,
   207,    34,   210,   145,   211,   209,     0,   214,     0,     0,
   214,   140,   213,   212,     0,     6,     0,     6,   141,   171,
   142,     0,     7,     0,     7,   141,   171,   142,     0,   216,
     0,   215,   140,   216,     0,     6,     0,     6,   141,   171,
   142,     0,     7,     0,     7,   141,   171,   142,     0,    10,
     0,   165,     0,   217,   140,    10,     0,   217,   140,   165,
     0,     0,   162,   219,     0,   218,   140,   162,   219,     0,
   159,     0,   218,   140,   159,     0,     0,    38,   159,     0,
     0,   226,   221,   212,     0,     0,   225,   222,   223,   212,
     0,     0,    10,     0,   226,     0,   225,     0,    48,   225,
     0,    49,   141,   159,   142,   225,     0,    49,   141,   159,
   140,   159,   142,   225,     0,     0,    46,   141,   162,   140,
   162,   142,     0,   143,   141,   162,   142,     0,   143,   228,
     0,   143,   162,     0,   162,     0,     9,     0,   167,     0,
   229,   140,   167,     0,   167,     0,   230,   140,   167,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   106,   109,   110,   111,   114,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   125,   126,   127,   128,   128,   129,
   129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
   139,   140,   141,   142,   143,   144,   145,   146,   146,   147,
   147,   148,   149,   150,   151,   158,   159,   160,   161,   162,
   164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
   174,   176,   177,   178,   179,   180,   181,   182,   183,   184,
   185,   186,   187,   188,   189,   190,   191,   192,   194,   195,
   196,   197,   198,   199,   200,   201,   204,   205,   206,   207,
   208,   211,   212,   216,   218,   222,   223,   226,   227,   228,
   229,   230,   231,   234,   235,   236,   237,   238,   239,   240,
   241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
   251,   252,   253,   254,   255,   256,   257,   258,   259,   262,
   263,   266,   267,   268,   269,   270,   271,   272,   273,   274,
   275,   276,   277,   278,   279,   280,   283,   286,   287,   288,
   289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
   299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
   309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
   319,   320,   321,   324,   325,   326,   329,   330,   333,   334,
   337,   338,   339,   340,   343,   346,   349,   350,   352,   353,
   354,   357,   358,   361,   362,   364,   366,   368,   369,   372,
   373,   375,   376,   379,   380,   381,   382,   385,   386,   389,
   390,   391,   392,   395,   396,   397,   400,   401,   402,   403,
   406,   410,   424,   425,   427,   430,   431,   434,   435,   438,
   439,   444,   444,   448,   452,   454,   458,   459,   461,   463,
   465,   466,   469,   470,   473,   474,   475,   476,   477,   478,
   479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
   489,   490,   491,   494,   495,   498,   499,   502,   504,   506,
   507,   508,   510,   511,   513,   514,   518,   519,   522,   523,
   525,   526,   530,   531,   532,   533,   536,   537,   538,   539,
   540,   543,   544,   547,   548,   548,   548,   551,   552,   555,
   556,   557,   558,   559,   562,   563,   566,   567,   570,   571,
   574,   576,   577,   580,   581
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","tSEP","tEOFILE",
"tFNUM","tSYMBOL","tSTRSYM","tDOCU","tDIGITS","tSTRING","tFOR","tTO","tSTEP",
"tNEXT","tWHILE","tWEND","tREPEAT","tUNTIL","tGOTO","tGOSUB","tLABEL","tON",
"tSUB","tENDSUB","tLOCAL","tSTATIC","tIMPORT","tEXPORT","tERROR","tINTERRUPT",
"tBREAK","tCONTINUE","tIF","tTHEN","tELSE","tELSIF","tENDIF","tUSING","tPRINT",
"tINPUT","tLINE","tRETURN","tDIM","tEND","tEXIT","tAT","tSCREEN","tREVERSE",
"tCOLOUR","tAND","tOR","tNOT","tNEQ","tLEQ","tGEQ","tLTN","tGTN","tEQU","tPOW",
"tREAD","tDATA","tRESTORE","tOPEN","tCLOSE","tORIGIN","tWINDOW","tDOT","tCIRCLE",
"tTEXT","tCLEAR","tPRINTER","tWAIT","tBELL","tARDIM","tARSIZE","tBOX","tRECT",
"tGETBIT","tPUTBIT","tGETCHAR","tPUTCHAR","tFRAME","tNEW","tCURVE","tSIN","tASIN",
"tCOS","tACOS","tTAN","tATAN","tEXP","tLOG","tSQRT","tSQR","tMYEOF","tABS","tSIG",
"tINT","tFRAC","tMOD","tRAN","tLEN","tVAL","tLEFT","tRIGHT","tMID","tMIN","tMAX",
"tSTR","tINKEY","tCHR","tASC","tHEX","tDEC","tUPPER","tLOWER","tMOUSEX","tMOUSEY",
"tMOUSEB","tTRIM","tLTRIM","tRTRIM","tINSTR","tSYSTEM","tSYSTEM2","tPEEK","tPEEK2",
"tPOKE","tDATE","tTIME","tTOKEN","tSPLIT","tGLOB","'-'","'+'","'*'","'/'","UMINUS",
"';'","','","'('","')'","'#'","program","statement_list","@1","@2","statement",
"@3","@4","@5","@6","@7","@8","string_assignment","to","open_clause","string_scalar_or_array",
"string_expression","string_function","assignment","expression","coordinates",
"function","const","number","symbol_or_lineno","dimlist","function_or_array",
"stringfunction_or_array","call_list","@9","calls","call_item","function_definition",
"@10","@11","@12","function_name","export","local_list","local_item","static_list",
"static_item","paramlist","paramitem","for_loop","@13","@14","@15","@16","next_or_eofile",
"step_part","next_symbol","while_loop","@17","@18","repeat_loop","@19","if_clause",
"@20","@21","@22","short_if","@23","endif_or_eof","condition","else_part","elsif_part",
"@24","@25","inputlist","@26","input","readlist","readitem","datalist","printlist",
"using","inputintro","@27","@28","prompt","printintro","position","stream","hashed_number",
"intnum","goto_list","gosub_list", NULL
};
#endif

static const short yyr1[] = {     0,
   144,   145,   146,   147,   145,   148,   148,   148,   148,   148,
   148,   148,   148,   148,   148,   148,   149,   148,   150,   148,
   148,   148,   148,   148,   148,   148,   151,   148,   152,   148,
   148,   148,   148,   148,   148,   148,   153,   148,   154,   148,
   148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
   148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
   148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
   148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
   148,   148,   148,   148,   148,   148,   155,   155,   155,   155,
   155,   156,   156,   157,   157,   158,   158,   159,   159,   159,
   159,   159,   159,   160,   160,   160,   160,   160,   160,   160,
   160,   160,   160,   160,   160,   160,   160,   160,   160,   160,
   160,   160,   160,   160,   160,   160,   160,   160,   160,   161,
   161,   162,   162,   162,   162,   162,   162,   162,   162,   162,
   162,   162,   162,   162,   162,   162,   163,   164,   164,   164,
   164,   164,   164,   164,   164,   164,   164,   164,   164,   164,
   164,   164,   164,   164,   164,   164,   164,   164,   164,   164,
   164,   164,   164,   164,   164,   164,   164,   164,   164,   164,
   164,   164,   164,   165,   165,   165,   166,   166,   167,   167,
   168,   168,   168,   168,   169,   170,   172,   171,   173,   173,
   173,   174,   174,   176,   177,   178,   175,   179,   179,   180,
   180,   181,   181,   182,   182,   182,   182,   183,   183,   184,
   184,   184,   184,   185,   185,   185,   186,   186,   186,   186,
   188,   189,   190,   191,   187,   192,   192,   193,   193,   194,
   194,   196,   197,   195,   199,   198,   201,   202,   203,   200,
   205,   204,   206,   206,   207,   207,   207,   207,   207,   207,
   207,   207,   207,   207,   207,   207,   207,   207,   207,   207,
   207,   207,   207,   208,   208,   209,   210,   211,   209,   212,
   213,   212,   214,   214,   214,   214,   215,   215,   216,   216,
   216,   216,   217,   217,   217,   217,   218,   218,   218,   218,
   218,   219,   219,   221,   220,   222,   220,   223,   223,   224,
   224,   224,   224,   224,   225,   225,   226,   226,   227,   227,
   228,   229,   229,   230,   230
};

static const short yyr2[] = {     0,
     2,     1,     0,     0,     5,     0,     1,     1,     2,     2,
     1,     1,     1,     1,     1,     1,     0,     3,     0,     3,
     1,     1,     2,     2,     3,     3,     0,     5,     0,     5,
     2,     1,     2,     3,     4,     4,     0,     3,     0,     4,
     2,     2,     1,     2,     1,     2,     2,     2,     5,     7,
     3,     2,     4,     3,     8,     6,     6,     2,     4,     4,
     6,     4,     4,     4,     5,     5,     2,     2,     2,     2,
     3,     2,     2,     1,     1,     3,     4,     4,     4,     4,
     4,     4,     1,     1,     2,     1,     3,    10,     8,     8,
     3,     1,     1,     6,     4,     1,     4,     1,     1,     1,
     1,     3,     3,     6,     6,     8,     4,     6,     1,     3,
     4,     4,     4,     4,     4,     4,     4,     4,     1,     1,
     4,     6,     6,     4,     6,     4,     6,    10,     4,     3,
     3,     1,     1,     4,     4,     6,     6,     1,     3,     1,
     3,     3,     3,     3,     3,     2,     3,     4,     4,     4,
     4,     4,     4,     6,     4,     4,     4,     4,     4,     4,
     4,     4,     6,     4,     3,     6,     6,     4,     4,     4,
     4,     6,     4,     4,     4,     4,     1,     4,     1,     4,
     1,     4,     6,     1,     2,     2,     1,     1,     1,     1,
     4,     6,     4,     6,     4,     4,     0,     2,     0,     1,
     3,     1,     1,     0,     0,     0,    11,     1,     1,     0,
     1,     1,     3,     1,     1,     4,     4,     1,     3,     1,
     1,     4,     4,     0,     1,     3,     1,     1,     3,     3,
     0,     0,     0,     0,    15,     1,     1,     0,     2,     0,
     1,     0,     0,     8,     0,     7,     0,     0,     0,    10,
     0,     4,     1,     1,     3,     3,     3,     2,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     4,     6,     1,     0,     2,     0,     0,     0,     7,     1,
     0,     4,     1,     4,     1,     4,     1,     3,     1,     4,
     1,     4,     1,     1,     3,     3,     0,     2,     4,     1,
     3,     0,     2,     0,     3,     0,     4,     0,     1,     1,
     1,     2,     5,     7,     0,     6,     4,     2,     2,     1,
     1,     1,     3,     1,     3
};

static const short yydefact[] = {     6,
     0,     0,    86,     0,   242,   245,     0,     0,     0,     0,
    17,    19,     0,   211,     0,     0,   315,    37,     0,    45,
     0,    83,    84,     0,     0,    43,     0,     0,     0,     0,
     0,     0,     0,     0,    74,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    75,     0,     0,     3,     2,     7,
    32,     8,    15,    16,    14,     0,    11,    13,    12,    21,
    22,     0,   197,     0,   197,     0,     0,     6,   190,   189,
    23,    24,    31,   187,   140,   188,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   177,   179,   181,     0,     0,     0,     0,     0,
     0,   133,   132,   138,     0,     0,     9,    98,   101,     0,
     0,     0,     0,     0,     0,   109,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   119,   120,     0,     0,     0,
    10,    99,   100,     0,     0,     0,     0,     0,   273,     0,
     0,   251,     0,   315,     0,     0,   297,   311,   310,   315,
    93,    39,    92,     0,     0,     0,     0,    47,    46,     0,
     0,    48,    85,   289,   291,    41,   287,   293,     0,     0,
   294,   184,    42,    44,     0,    70,     0,   320,     0,    67,
    72,    33,     0,    52,     0,     0,    69,    68,     0,     0,
    73,     0,     0,     0,     0,     0,    58,     0,     0,     0,
     0,     0,     0,     0,     1,     0,     0,     0,   204,   130,
     0,   199,    87,     0,   231,     0,     3,    25,    26,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   146,     0,    27,    29,     0,     0,     0,     0,     0,   214,
   215,    18,   212,   220,   221,    20,   218,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   258,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     6,
     0,   312,     0,   321,     0,   318,   300,   302,    34,    38,
   306,   304,   315,    54,     0,     0,   197,   197,     0,   197,
   197,     0,   186,   185,     0,     0,    71,   319,     0,    51,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    96,
     0,     0,     0,    76,     0,     0,     0,     0,     4,   131,
    91,     0,   195,   202,   203,   198,   200,   196,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   165,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   139,     0,     0,   145,
   142,   141,   143,   144,   197,   197,     0,   197,   197,     0,
     0,     0,     0,     0,     0,     0,   110,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   103,
   102,     0,     0,   255,   260,   262,   264,   261,   263,   259,
   266,   268,   270,   267,   269,   265,   257,   256,     6,   252,
     0,     0,     0,     0,   298,    35,    36,   308,     0,    40,
   147,    53,     0,     0,     0,     0,     0,     0,   288,   295,
   296,     0,    95,    59,    60,     0,     0,    62,    64,     0,
     0,    63,   197,     0,     0,     0,    77,    78,    79,    80,
    81,    82,     6,   208,   209,   205,     0,     0,   243,     0,
     0,   182,   135,   134,     0,     0,   148,   149,   150,   151,
   152,     0,   153,   155,   156,   157,   158,   161,   162,   159,
   160,     0,   164,   168,   169,     0,     0,   170,   171,   176,
   178,   180,     0,   173,   175,   174,   322,    28,   324,    30,
     0,     0,   213,     0,     0,   219,     0,     0,     0,     0,
     0,     0,   107,   111,   112,   129,   113,   114,   117,   115,
   116,   118,     0,   121,     0,   124,     0,   126,   271,     0,
   248,     0,     0,   315,   317,   303,   301,   302,   309,     0,
   283,   285,   305,   280,   191,   193,   197,   197,   290,   292,
    49,     0,     0,    66,    65,     0,     0,     0,     0,     0,
     0,     5,     0,   201,     0,     6,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   216,   217,   222,
   223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   276,     0,     0,   313,   299,   307,   197,   197,   281,
     0,     0,     0,    94,    61,    56,    57,    97,     0,     0,
     0,   224,   238,     3,   246,   183,   137,   136,   154,   163,
   166,   167,   172,   323,   325,   127,     0,   104,   105,     0,
   108,   122,   123,   125,   272,     0,   274,   316,   315,     0,
     0,     0,   192,   194,    50,     0,     0,     0,     0,   227,
   228,     0,   225,     0,   232,   244,     0,     0,     0,     6,
   249,   314,   284,   286,   282,    55,    89,    90,     0,     0,
     0,     0,   206,   239,     0,     0,   106,   277,   275,     0,
     0,   229,   230,   226,     6,   233,     0,     6,   254,   253,
   250,    88,     3,     6,   128,   278,   207,   234,   276,     0,
   279,   237,   236,   240,   241,   235,     0,     0,     0
};

static const short yydefgoto[] = {   767,
    48,   216,   513,    49,   115,   116,   418,   419,   160,   333,
    50,   164,    51,   361,   150,   142,    52,   165,   166,   112,
   181,   113,    71,   172,   114,   143,   221,   222,   376,   377,
    55,   372,   623,   745,   516,    56,   272,   273,   276,   277,
   712,   713,    57,   379,   735,   754,   760,   764,   715,   766,
    58,    67,   626,    59,    68,    60,   319,   652,   740,    61,
   320,   751,   152,   721,   697,   748,   759,   603,   702,   604,
   176,   177,   183,   329,   475,   330,   479,   478,   600,   157,
   331,   332,   189,   326,   558,   560
};

static const short yypact[] = {  1924,
    -1,     3,-32768,    35,-32768,-32768,    24,    24,    24,  1735,
-32768,-32768,    76,-32768,   655,  1401,    -6,-32768,  1661,  1531,
    90,-32768,  1799,   247,    14,    24,   937,  1001,    21,  1799,
  1799,  1799,    -3,  1799,-32768,  1799,  1799,   655,   655,  1799,
   -25,    25,    41,    51,    61,    69,   807,   121,-32768,-32768,
-32768,-32768,    74,   100,-32768,   118,-32768,-32768,-32768,-32768,
-32768,  1799,-32768,   655,-32768,   168,   148,  1924,-32768,-32768,
-32768,-32768,-32768,-32768,   177,-32768,   305,   185,   207,   209,
   227,   259,   292,   296,   298,   302,   370,   371,   376,   388,
   394,   395,   402,   409,   410,   411,   419,   424,   429,   430,
   436,   437,   440,   441,   446,   447,   448,   451,  1799,  1799,
    34,-32768,-32768,-32768,   333,   357,-32768,   452,-32768,   458,
   467,   468,   471,   480,   481,   496,   497,   502,   503,   507,
   508,   509,   516,   522,   523,-32768,-32768,   525,   526,   655,
   167,-32768,-32768,  1401,  1076,   527,   529,  1401,-32768,   237,
   288,    28,   530,   341,   531,     4,  1531,-32768,-32768,   -26,
-32768,-32768,-32768,  1799,   539,    17,  1531,   167,   125,   541,
   546,   250,   125,   549,   550,   276,-32768,-32768,    67,    67,
-32768,-32768,   343,-32768,  1799,   655,  1799,   125,   398,-32768,
-32768,-32768,   655,-32768,   422,   461,-32768,-32768,  1799,  1799,
   125,    17,    17,    27,    27,    17,-32768,   600,   600,   600,
  1140,   655,   -29,   470,-32768,   534,  1799,   655,-32768,   125,
   492,  1531,   167,   551,-32768,  1401,   617,-32768,-32768,   655,
  1531,  1531,  1799,  1799,  1799,  1799,  1799,  1799,  1799,  1799,
  1799,  1799,  1799,  1799,  1799,  1799,  1799,  1215,   655,   655,
  1799,  1799,   655,   655,   655,   655,   655,   655,   655,   807,
-32768,   134,-32768,-32768,  1799,  1799,  1799,  1799,  1799,   554,
   557,   563,-32768,   564,   567,   566,-32768,  1799,  1799,   655,
   655,   655,  1799,  1279,  1799,  1799,   655,   655,   655,   655,
   655,   655,   655,   600,   600,   -77,   655,-32768,  1531,  1799,
   655,    66,   397,     5,   655,   655,   655,   655,   655,   655,
  1799,  1799,  1799,  1799,  1799,  1799,  1401,  1401,   670,  1924,
  1799,-32768,   655,-32768,  1799,-32768,   167,   -21,   246,-32768,
-32768,-32768,   -26,-32768,  1799,  1799,-32768,-32768,   396,-32768,
-32768,   247,-32768,-32768,    26,   881,   167,   125,   655,   167,
  1799,   655,    17,    17,  1799,  1799,  1799,  1799,  1799,   568,
   570,   573,   574,-32768,   271,   -71,  1531,  1531,-32768,   125,
   167,   466,-32768,   167,   125,   576,-32768,-32768,  1799,    30,
   577,   -50,   -51,   275,    -9,  1315,   323,   342,   359,   412,
   421,    -7,   438,   449,   460,   469,   483,   494,   505,   517,
  1325,-32768,   565,   -41,   -40,  1333,  1412,    65,    86,   113,
   138,   143,    56,   182,   193,   575,-32768,    24,    24,-32768,
   -32,   -32,   660,   660,-32768,-32768,   333,-32768,-32768,   357,
    17,  1419,    87,   116,   117,    77,-32768,   602,   656,   669,
   196,   225,   238,   239,   249,   299,    64,   132,   146,-32768,
-32768,   688,   164,-32768,   167,   167,   167,   167,   167,   167,
   125,   125,   125,   125,   125,   125,-32768,   673,  1924,-32768,
  1426,    83,   697,   655,-32768,-32768,  1531,   715,   493,-32768,
   125,-32768,   585,   588,   590,   599,   601,   608,-32768,-32768,
-32768,  1799,   165,   125,   187,  1799,  1799,-32768,-32768,  1540,
  1548,-32768,-32768,  1799,  1799,  1799,-32768,-32768,   167,   125,
   167,   125,  1924,-32768,-32768,-32768,  1531,    39,-32768,  1401,
   655,-32768,-32768,-32768,  1799,  1799,-32768,-32768,-32768,-32768,
-32768,  1799,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,  1799,-32768,-32768,-32768,  1799,  1799,-32768,-32768,-32768,
-32768,-32768,   655,-32768,-32768,-32768,-32768,   613,-32768,   618,
   615,   620,-32768,   621,   625,-32768,  1799,  1799,  1799,  1799,
  1799,   655,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   655,-32768,   655,-32768,   655,-32768,-32768,   655,
   738,  1799,   655,   341,-32768,   167,   167,   -21,-32768,   493,
   628,   631,-32768,   634,-32768,-32768,-32768,-32768,-32768,-32768,
  1555,   655,   655,-32768,-32768,  1799,  1799,   636,   714,   724,
  1654,-32768,   639,-32768,  1799,  1924,    37,   300,   741,   820,
   829,   843,   994,  1018,   326,    24,    24,-32768,-32768,-32768,
-32768,   646,    16,  1133,  1157,  1678,   339,   347,   350,   363,
   374,   706,  1280,   385,-32768,-32768,-32768,-32768,-32768,-32768,
   647,   652,   655,   167,   167,  1875,   125,-32768,   723,   737,
  1799,   519,    53,   781,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,  1799,-32768,-32768,  1799,
-32768,-32768,-32768,-32768,-32768,  1401,   764,-32768,   341,   659,
   665,   493,-32768,-32768,   167,   655,   655,   655,  1289,   667,
   668,   161,-32768,  1799,-32768,-32768,  1883,  1293,    49,  1924,
-32768,-32768,-32768,-32768,-32768,   167,   167,   167,   752,   678,
   679,   519,-32768,   125,   812,  1799,-32768,-32768,   738,    33,
   655,-32768,-32768,-32768,  1924,-32768,  1302,  1924,-32768,-32768,
-32768,   167,   802,  1924,-32768,   738,-32768,   738,   706,    63,
-32768,-32768,-32768,   821,-32768,-32768,   828,   835,-32768
};

static const short yypgoto[] = {-32768,
   -65,-32768,-32768,  -308,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,  -156,   -10,  -100,   139,-32768,-32768,    -2,   322,-32768,
   484,   -16,    -4,-32768,     0,     1,    38,-32768,-32768,   319,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   413,-32768,   407,
-32768,   106,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,  -137,-32768,    82,-32768,-32768,  -584,-32768,-32768,
-32768,   500,-32768,-32768,   245,   511,-32768,-32768,-32768,-32768,
   -15,   836,   -13,-32768,-32768,-32768
};


#define	YYLAST		2052


static const short yytable[] = {    53,
    54,   158,   227,    72,    73,   149,   298,   111,   182,   336,
   304,   470,   324,   151,   192,   657,   474,   169,    74,   153,
   173,   184,    76,   178,   188,   188,   265,   161,   161,    69,
    74,   201,    70,   214,    76,   490,   749,   265,   161,   153,
    66,   154,   155,   197,   188,   355,   356,   357,   358,   359,
   625,   265,   263,   264,   317,   318,    62,   297,   207,   220,
    64,  -247,   198,   297,   450,   714,   762,    53,    54,   750,
   508,    74,   199,   200,   265,    76,   763,   317,   318,   317,
   318,   117,   738,   297,   297,   193,   317,   318,   380,   521,
   523,   522,   265,   297,   297,   170,   171,   265,   317,   318,
   544,   545,   224,   268,   269,   297,   261,   262,   362,   363,
   367,   265,   266,   267,   268,   269,   156,   725,   305,   306,
   307,   308,   309,   310,   215,   297,   266,   267,   268,   269,
   525,   217,   532,   149,   533,   265,   156,   149,   322,    63,
   219,   151,   188,    65,   325,   303,   454,   179,   180,   266,
   267,   268,   269,   141,   328,   163,   163,   218,   168,   179,
   180,   297,   343,   344,   262,   208,   163,   266,   267,   268,
   269,   519,   266,   267,   268,   269,   204,   205,   675,   467,
   468,   209,   346,   265,   348,   213,   266,   267,   268,   269,
   297,   210,   265,   448,   449,   553,   496,   497,   297,   297,
   297,   211,   223,   583,   622,   584,   548,   450,   365,   212,
   266,   267,   268,   269,   370,   149,   572,   297,   573,   375,
   297,   297,   593,   151,   594,   225,   569,   549,   384,   386,
   387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
   397,   398,   399,   400,   401,   403,   416,   297,   406,   407,
   297,   297,   174,   175,   550,   570,   571,   188,   266,   267,
   268,   269,   420,   421,   422,   423,   424,   266,   267,   268,
   269,   585,   297,   586,   567,   417,   432,   297,   296,   551,
   436,   438,   439,   440,   552,   587,   302,   588,   226,   305,
   306,   307,   308,   309,   310,   327,   262,   452,   297,   297,
   732,   297,   733,   590,   612,   296,   149,   149,   461,   462,
   463,   464,   465,   466,   151,   151,   297,    63,   471,    53,
    54,   297,   473,   554,   347,   230,   613,   297,   182,   265,
   297,   350,   481,   265,   555,   228,   229,   577,   270,   271,
   311,   312,   313,   314,   315,   316,   265,   231,   494,   232,
   366,   194,   195,   196,   500,   501,   371,   202,   203,   297,
   374,   206,   274,   275,   510,   512,   578,   233,   382,   383,
   385,   297,   297,   297,   483,   484,   518,   487,   488,   579,
   580,   265,   627,   297,   476,   477,   153,   404,   405,   339,
   581,   408,   409,   410,   411,   412,   413,   414,   415,   234,
   265,   485,   486,   591,   266,   267,   268,   269,   266,   267,
   268,   269,   507,   557,   559,   342,   524,   265,   433,   434,
   435,   266,   267,   268,   269,   441,   442,   443,   444,   445,
   446,   447,   235,   297,   297,   451,   236,   382,   237,   453,
   582,   676,   238,   455,   456,   457,   458,   459,   460,   311,
   312,   313,   314,   315,   316,   265,   266,   267,   268,   269,
   297,   472,   561,   562,   527,   564,   565,   683,    53,    54,
   265,   514,   515,   297,   598,   266,   267,   268,   269,   265,
   691,   297,   345,   528,   297,   334,   687,   493,   692,   611,
   495,   693,   266,   267,   268,   269,   265,   297,   601,   602,
   529,   619,   620,   621,   694,   509,   511,   265,   297,   149,
   239,   240,    53,    54,   375,   695,   241,   151,   265,   297,
   353,   354,   629,   630,   710,   711,   699,   265,   242,   631,
   266,   267,   268,   269,   243,   244,   369,   349,   417,   632,
   618,   265,   245,   633,   634,   266,   267,   268,   269,   246,
   247,   248,   265,   530,   266,   267,   268,   269,   719,   249,
   674,   351,   531,   265,   250,   643,   644,   645,   646,   251,
   252,   266,   267,   268,   269,   265,   253,   254,   655,   534,
   255,   256,   266,   267,   268,   269,   257,   258,   259,   653,
   535,   260,    65,   266,   267,   268,   269,   265,   278,   431,
   352,   536,   266,   267,   268,   269,   360,   279,   280,   368,
   537,   281,   596,   666,   667,   597,   266,   267,   268,   269,
   282,   283,   673,   265,   538,    53,    54,   266,   267,   268,
   269,   684,   685,   373,   381,   539,   284,   285,   266,   267,
   268,   269,   286,   287,   661,   662,   540,   288,   289,   290,
   266,   267,   268,   269,   739,   374,   291,   482,   541,   628,
   265,   118,   292,   293,   119,   294,   295,   300,   709,   301,
   321,   323,   266,   267,   268,   269,   498,   499,   335,   753,
   502,   337,   756,   722,   717,   149,   338,   718,   758,   340,
   341,   635,   378,   151,   425,   700,   701,   426,   266,   267,
   268,   269,   427,   469,   428,   430,   543,   429,   503,   504,
   647,   734,   505,   506,   265,   517,   556,   520,   265,    53,
    54,   648,   317,   649,   599,   650,   605,   265,   651,   606,
   607,   654,   120,   747,   121,   266,   267,   268,   269,   608,
    -3,   696,   609,   574,    53,    54,   265,    53,    54,   610,
   664,   665,   636,    53,    54,   265,   638,   637,   122,   123,
   124,   639,   640,   125,   126,   127,   641,   128,   658,   129,
   130,   659,   265,   660,   131,   132,   133,   668,   134,   672,
   707,   135,   265,   136,   137,   138,   139,   686,   703,   266,
   267,   268,   269,   704,   708,   140,   716,   575,   720,   265,
   723,   705,   266,   267,   268,   269,   724,   730,   731,   741,
   576,    74,    75,   118,   746,    76,   119,   614,   615,   742,
   743,   266,   267,   268,   269,   757,   765,   768,   491,   589,
   266,   267,   268,   269,   769,   624,   566,   744,   595,   563,
   761,   489,   656,   480,   726,   727,   728,   266,   267,   268,
   269,     0,   159,     0,     0,   669,     0,   266,   267,   268,
   269,     0,     0,     0,     0,   670,     0,     0,     0,    78,
     0,     0,     0,     0,   266,   267,   268,   269,   265,   752,
    79,    80,   677,     0,   120,     0,   121,   265,   642,     0,
     0,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,   265,    91,    92,    93,    94,    95,    96,    97,    98,
   122,   123,   124,    99,   100,   125,   126,   127,   101,   128,
   102,   129,   130,   103,   104,   105,   131,   132,   133,   106,
   134,   107,   108,   135,     0,   136,   137,   138,   139,   265,
   109,    74,    75,     0,     0,    76,     0,   167,     0,   187,
     0,     0,     0,   266,   267,   268,   269,     0,     0,     0,
     0,   678,   266,   267,   268,   269,     0,     0,     0,     0,
   679,     0,     0,     0,     0,     0,   266,   267,   268,   269,
     0,     0,     0,     0,   680,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    78,
     0,     0,   185,     0,     0,    74,    75,   186,     0,    76,
    79,    80,     0,     0,   266,   267,   268,   269,     0,     0,
   492,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,     0,    91,    92,    93,    94,    95,    96,    97,    98,
     0,     0,     0,    99,   100,     0,     0,     0,   101,     0,
   102,     0,   265,   103,   104,   105,     0,     0,     0,   106,
     0,   107,   108,    78,     0,     0,   190,     0,     0,     0,
   109,   191,     0,     0,    79,    80,   265,   110,     0,   187,
    74,    75,     0,     0,    76,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,     0,    91,    92,    93,    94,
    95,    96,    97,    98,     0,     0,     0,    99,   100,     0,
     0,     0,   101,     0,   102,     0,     0,   103,   104,   105,
     0,     0,     0,   106,     0,   107,   108,   266,   267,   268,
   269,     0,     0,     0,   109,   681,     0,     0,    78,     0,
     0,   110,     0,   187,    74,    75,     0,     0,    76,    79,
    80,   266,   267,   268,   269,     0,     0,     0,     0,   682,
    81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
     0,    91,    92,    93,    94,    95,    96,    97,    98,     0,
     0,     0,    99,   100,     0,     0,     0,   101,     0,   102,
     0,   265,   103,   104,   105,     0,     0,     0,   106,     0,
   107,   108,    78,     0,     0,     0,     0,     0,     0,   109,
     0,     0,     0,    79,    80,   265,   299,     0,   187,    74,
    75,     0,     0,    76,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,     0,    91,    92,    93,    94,    95,
    96,    97,    98,     0,     0,     0,    99,   100,     0,     0,
     0,   101,     0,   102,     0,     0,   103,   104,   105,     0,
     0,     0,   106,     0,   107,   108,   266,   267,   268,   269,
     0,     0,     0,   109,   688,     0,     0,    78,     0,     0,
   110,   364,     0,    74,    75,     0,     0,    76,    79,    80,
   266,   267,   268,   269,     0,     0,     0,     0,   689,    81,
    82,    83,    84,    85,    86,    87,    88,    89,    90,     0,
    91,    92,    93,    94,    95,    96,    97,    98,     0,     0,
     0,    99,   100,     0,     0,     0,   101,     0,   102,     0,
     0,   103,   104,   105,     0,     0,     0,   106,   265,   107,
   108,    78,     0,     0,     0,     0,     0,   265,   109,     0,
     0,   265,    79,    80,     0,   110,   402,     0,     0,     0,
   265,     0,     0,    81,    82,    83,    84,    85,    86,    87,
    88,    89,    90,   265,    91,    92,    93,    94,    95,    96,
    97,    98,     0,   265,     0,    99,   100,     0,     0,     0,
   101,   265,   102,     0,     0,   103,   104,   105,     0,     0,
     0,   106,     0,   107,   108,    74,    75,   118,     0,    76,
   119,     0,   109,   266,   267,   268,   269,     0,     0,   110,
   437,   698,   266,   267,   268,   269,   266,   267,   268,   269,
   729,     0,     0,     0,   737,   266,   267,   268,   269,     0,
     0,     0,     0,   755,     0,     0,     0,     0,   266,   267,
   268,   269,   144,     0,   526,     0,     0,     0,   266,   267,
   268,   269,     0,   145,   542,     0,   266,   267,   268,   269,
   265,     0,   546,     0,    79,    80,     0,   265,   120,     0,
   121,     0,     0,     0,   265,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,   146,    91,    92,    93,    94,
    95,    96,    97,    98,   122,   123,   124,    99,   100,   125,
   126,   127,   101,   128,   102,   129,   130,   103,   104,   105,
   131,   132,   133,   106,   134,   107,   108,   135,     0,   136,
   137,   138,   139,   147,   109,    74,    75,   118,     0,    76,
   119,   148,     0,     0,     0,   266,   267,   268,   269,     0,
     0,   547,   266,   267,   268,   269,     0,     0,   568,   266,
   267,   268,   269,     0,     0,   592,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    78,     0,     0,     0,     0,   265,     0,
     0,     0,     0,     0,    79,    80,   265,     0,   120,     0,
   121,     0,     0,   265,     0,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,     0,    91,    92,    93,    94,
    95,    96,    97,    98,   122,   123,   124,    99,   100,   125,
   126,   127,   101,   128,   102,   129,   130,   103,   104,   105,
   131,   132,   133,   106,   134,   107,   108,   135,     0,   136,
   137,   138,   139,     0,   109,    74,    75,     0,     0,    76,
     0,   167,   161,   266,   267,   268,   269,     0,     0,   616,
     0,   266,   267,   268,   269,     0,     0,   617,   266,   267,
   268,   269,     0,     0,   663,     0,     0,     0,     0,     0,
   162,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   265,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    78,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    79,    80,   265,     0,     0,    74,
    75,     0,     0,    76,     0,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,     0,    91,    92,    93,    94,
    95,    96,    97,    98,    77,     0,     0,    99,   100,     0,
     0,     0,   101,     0,   102,     0,     0,   103,   104,   105,
     0,     0,     0,   106,     0,   107,   108,   266,   267,   268,
   269,     0,     0,   671,   109,     0,     0,    78,     0,     0,
   163,   110,     0,    74,    75,     0,     0,    76,    79,    80,
     0,   266,   267,   268,   269,     0,     0,   690,     0,    81,
    82,    83,    84,    85,    86,    87,    88,    89,    90,     0,
    91,    92,    93,    94,    95,    96,    97,    98,     0,     0,
     0,    99,   100,     0,     0,     0,   101,     0,   102,     0,
     0,   103,   104,   105,     0,     0,     0,   106,     0,   107,
   108,    78,     0,     0,     0,     0,     0,     0,   109,     0,
     0,     0,    79,    80,     0,   110,     0,     0,     0,     0,
     0,     0,     0,    81,    82,    83,    84,    85,    86,    87,
    88,    89,    90,     0,    91,    92,    93,    94,    95,    96,
    97,    98,     0,     0,     0,    99,   100,     0,     0,     0,
   101,     0,   102,     0,     0,   103,   104,   105,     0,     0,
     0,   106,     0,   107,   108,     0,     0,     0,     0,     1,
     2,     3,   109,   265,     4,     0,     0,     0,     5,   110,
     6,   265,     7,     8,     9,    10,  -210,     0,    11,    12,
    13,    14,    15,     0,     0,     0,    16,     0,     0,     0,
     0,     0,    17,    18,    19,    20,    21,    22,    23,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    24,    25,    26,    27,    28,     0,    29,
    30,    31,    32,    33,     0,    34,    35,     0,     0,    36,
    37,     0,    38,     0,    39,    40,    41,     0,   266,   267,
   268,   269,     0,     0,   706,     0,   266,   267,   268,   269,
     0,     0,   736,     0,     0,     0,     0,    42,    43,    44,
     0,     0,     0,    45,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    46,     0,
     0,    47
};

static const short yycheck[] = {     0,
     0,    17,    68,     8,     9,    16,   144,    10,    25,   166,
   148,   320,     9,    16,    28,   600,    38,    20,     5,    46,
    23,    26,     9,    10,    27,    28,    59,    12,    12,     6,
     5,    34,     9,    47,     9,    10,     4,    59,    12,    46,
     6,    48,    49,    47,    47,   202,   203,   204,   205,   206,
    12,    59,    19,    20,    50,    51,    58,   135,    84,    62,
    58,    34,    66,   135,   142,    13,     4,    68,    68,    37,
   142,     5,    76,    77,    59,     9,    14,    50,    51,    50,
    51,     6,    34,   135,   135,    65,    50,    51,   226,   140,
   142,   142,    59,   135,   135,     6,     7,    59,    50,    51,
   142,   142,    65,   136,   137,   135,   109,   110,   209,   210,
   140,    59,   134,   135,   136,   137,   143,   702,    53,    54,
    55,    56,    57,    58,     4,   135,   134,   135,   136,   137,
   140,    58,   140,   144,   142,    59,   143,   148,   154,   141,
    23,   144,   145,   141,   141,   148,   142,   134,   135,   134,
   135,   136,   137,    15,   157,   140,   140,    58,    20,   134,
   135,   135,   179,   180,   167,   141,   140,   134,   135,   136,
   137,   142,   134,   135,   136,   137,    38,    39,   142,   317,
   318,   141,   185,    59,   187,    47,   134,   135,   136,   137,
   135,   141,    59,   294,   295,   140,   353,   354,   135,   135,
   135,   141,    64,   140,   513,   142,   142,   142,   211,   141,
   134,   135,   136,   137,   217,   226,   140,   135,   142,   222,
   135,   135,   140,   226,   142,    58,   140,   142,   231,   232,
   233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
   243,   244,   245,   246,   247,   248,   260,   135,   251,   252,
   135,   135,     6,     7,   142,   140,   140,   260,   134,   135,
   136,   137,   265,   266,   267,   268,   269,   134,   135,   136,
   137,   140,   135,   142,   431,   142,   279,   135,   140,   142,
   283,   284,   285,   286,   142,   140,   148,   142,   141,    53,
    54,    55,    56,    57,    58,   157,   299,   300,   135,   135,
   140,   135,   142,   140,   140,   167,   317,   318,   311,   312,
   313,   314,   315,   316,   317,   318,   135,   141,   321,   320,
   320,   135,   325,   142,   186,   141,   140,   135,   345,    59,
   135,   193,   335,    59,   142,    31,    32,   142,     6,     7,
    53,    54,    55,    56,    57,    58,    59,   141,   351,   141,
   212,    30,    31,    32,   357,   358,   218,    36,    37,   135,
   222,    40,     6,     7,   367,   368,   142,   141,   230,   231,
   232,   135,   135,   135,   337,   338,   379,   340,   341,   142,
   142,    59,   520,   135,   139,   140,    46,   249,   250,   140,
   142,   253,   254,   255,   256,   257,   258,   259,   260,   141,
    59,     6,     7,   469,   134,   135,   136,   137,   134,   135,
   136,   137,   142,   418,   419,   140,   142,    59,   280,   281,
   282,   134,   135,   136,   137,   287,   288,   289,   290,   291,
   292,   293,   141,   135,   135,   297,   141,   299,   141,   301,
   142,   142,   141,   305,   306,   307,   308,   309,   310,    53,
    54,    55,    56,    57,    58,    59,   134,   135,   136,   137,
   135,   323,   425,   426,   142,   428,   429,   142,   469,   469,
    59,     6,     7,   135,   477,   134,   135,   136,   137,    59,
   142,   135,   140,   142,   135,   164,   643,   349,   142,   492,
   352,   142,   134,   135,   136,   137,    59,   135,     6,     7,
   142,   504,   505,   506,   142,   367,   368,    59,   135,   520,
   141,   141,   513,   513,   517,   142,   141,   520,    59,   135,
   199,   200,   525,   526,     6,     7,   142,    59,   141,   532,
   134,   135,   136,   137,   141,   141,     3,   140,   142,   542,
   503,    59,   141,   546,   547,   134,   135,   136,   137,   141,
   141,   141,    59,   142,   134,   135,   136,   137,   696,   141,
   626,   140,   142,    59,   141,   568,   569,   570,   571,   141,
   141,   134,   135,   136,   137,    59,   141,   141,   594,   142,
   141,   141,   134,   135,   136,   137,   141,   141,   141,   592,
   142,   141,   141,   134,   135,   136,   137,    59,   141,   278,
   140,   142,   134,   135,   136,   137,     7,   141,   141,   140,
   142,   141,   474,   616,   617,   477,   134,   135,   136,   137,
   141,   141,   625,    59,   142,   626,   626,   134,   135,   136,
   137,   636,   637,   142,    18,   142,   141,   141,   134,   135,
   136,   137,   141,   141,   607,   608,   142,   141,   141,   141,
   134,   135,   136,   137,   720,   517,   141,   336,   142,   521,
    59,     7,   141,   141,    10,   141,   141,   141,   671,   141,
   141,   141,   134,   135,   136,   137,   355,   356,   140,   745,
   359,   141,   748,   699,   687,   696,   141,   690,   754,   141,
   141,   553,   142,   696,   141,   658,   659,   141,   134,   135,
   136,   137,   140,    34,   141,   140,   142,   141,   141,   140,
   572,   714,   140,   140,    59,   140,   142,   141,    59,   720,
   720,   583,    50,   585,    10,   587,   142,    59,   590,   142,
   141,   593,    78,   736,    80,   134,   135,   136,   137,   141,
     3,    36,   142,   142,   745,   745,    59,   748,   748,   142,
   612,   613,   140,   754,   754,    59,   142,   140,   104,   105,
   106,   142,   142,   109,   110,   111,   142,   113,   141,   115,
   116,   141,    59,   140,   120,   121,   122,   142,   124,   141,
    58,   127,    59,   129,   130,   131,   132,   142,   142,   134,
   135,   136,   137,   142,    58,   141,    16,   142,    35,    59,
   142,   663,   134,   135,   136,   137,   142,   141,   141,    58,
   142,     5,     6,     7,     3,     9,    10,   496,   497,   142,
   142,   134,   135,   136,   137,    24,     6,     0,   345,   142,
   134,   135,   136,   137,     0,   517,   430,   732,   142,   427,
   759,   342,   598,   333,   706,   707,   708,   134,   135,   136,
   137,    -1,    17,    -1,    -1,   142,    -1,   134,   135,   136,
   137,    -1,    -1,    -1,    -1,   142,    -1,    -1,    -1,    63,
    -1,    -1,    -1,    -1,   134,   135,   136,   137,    59,   741,
    74,    75,   142,    -1,    78,    -1,    80,    59,   567,    -1,
    -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
    94,    59,    96,    97,    98,    99,   100,   101,   102,   103,
   104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   125,   126,   127,    -1,   129,   130,   131,   132,    59,
   134,     5,     6,    -1,    -1,     9,    -1,   141,    -1,   143,
    -1,    -1,    -1,   134,   135,   136,   137,    -1,    -1,    -1,
    -1,   142,   134,   135,   136,   137,    -1,    -1,    -1,    -1,
   142,    -1,    -1,    -1,    -1,    -1,   134,   135,   136,   137,
    -1,    -1,    -1,    -1,   142,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
    -1,    -1,    66,    -1,    -1,     5,     6,    71,    -1,     9,
    74,    75,    -1,    -1,   134,   135,   136,   137,    -1,    -1,
   140,    85,    86,    87,    88,    89,    90,    91,    92,    93,
    94,    -1,    96,    97,    98,    99,   100,   101,   102,   103,
    -1,    -1,    -1,   107,   108,    -1,    -1,    -1,   112,    -1,
   114,    -1,    59,   117,   118,   119,    -1,    -1,    -1,   123,
    -1,   125,   126,    63,    -1,    -1,    66,    -1,    -1,    -1,
   134,    71,    -1,    -1,    74,    75,    59,   141,    -1,   143,
     5,     6,    -1,    -1,     9,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    -1,    96,    97,    98,    99,
   100,   101,   102,   103,    -1,    -1,    -1,   107,   108,    -1,
    -1,    -1,   112,    -1,   114,    -1,    -1,   117,   118,   119,
    -1,    -1,    -1,   123,    -1,   125,   126,   134,   135,   136,
   137,    -1,    -1,    -1,   134,   142,    -1,    -1,    63,    -1,
    -1,   141,    -1,   143,     5,     6,    -1,    -1,     9,    74,
    75,   134,   135,   136,   137,    -1,    -1,    -1,    -1,   142,
    85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
    -1,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
    -1,    -1,   107,   108,    -1,    -1,    -1,   112,    -1,   114,
    -1,    59,   117,   118,   119,    -1,    -1,    -1,   123,    -1,
   125,   126,    63,    -1,    -1,    -1,    -1,    -1,    -1,   134,
    -1,    -1,    -1,    74,    75,    59,   141,    -1,   143,     5,
     6,    -1,    -1,     9,    85,    86,    87,    88,    89,    90,
    91,    92,    93,    94,    -1,    96,    97,    98,    99,   100,
   101,   102,   103,    -1,    -1,    -1,   107,   108,    -1,    -1,
    -1,   112,    -1,   114,    -1,    -1,   117,   118,   119,    -1,
    -1,    -1,   123,    -1,   125,   126,   134,   135,   136,   137,
    -1,    -1,    -1,   134,   142,    -1,    -1,    63,    -1,    -1,
   141,   142,    -1,     5,     6,    -1,    -1,     9,    74,    75,
   134,   135,   136,   137,    -1,    -1,    -1,    -1,   142,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    -1,
    96,    97,    98,    99,   100,   101,   102,   103,    -1,    -1,
    -1,   107,   108,    -1,    -1,    -1,   112,    -1,   114,    -1,
    -1,   117,   118,   119,    -1,    -1,    -1,   123,    59,   125,
   126,    63,    -1,    -1,    -1,    -1,    -1,    59,   134,    -1,
    -1,    59,    74,    75,    -1,   141,   142,    -1,    -1,    -1,
    59,    -1,    -1,    85,    86,    87,    88,    89,    90,    91,
    92,    93,    94,    59,    96,    97,    98,    99,   100,   101,
   102,   103,    -1,    59,    -1,   107,   108,    -1,    -1,    -1,
   112,    59,   114,    -1,    -1,   117,   118,   119,    -1,    -1,
    -1,   123,    -1,   125,   126,     5,     6,     7,    -1,     9,
    10,    -1,   134,   134,   135,   136,   137,    -1,    -1,   141,
   142,   142,   134,   135,   136,   137,   134,   135,   136,   137,
   142,    -1,    -1,    -1,   142,   134,   135,   136,   137,    -1,
    -1,    -1,    -1,   142,    -1,    -1,    -1,    -1,   134,   135,
   136,   137,    52,    -1,   140,    -1,    -1,    -1,   134,   135,
   136,   137,    -1,    63,   140,    -1,   134,   135,   136,   137,
    59,    -1,   140,    -1,    74,    75,    -1,    59,    78,    -1,
    80,    -1,    -1,    -1,    59,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
   100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
   130,   131,   132,   133,   134,     5,     6,     7,    -1,     9,
    10,   141,    -1,    -1,    -1,   134,   135,   136,   137,    -1,
    -1,   140,   134,   135,   136,   137,    -1,    -1,   140,   134,
   135,   136,   137,    -1,    -1,   140,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    63,    -1,    -1,    -1,    -1,    59,    -1,
    -1,    -1,    -1,    -1,    74,    75,    59,    -1,    78,    -1,
    80,    -1,    -1,    59,    -1,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    -1,    96,    97,    98,    99,
   100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
   130,   131,   132,    -1,   134,     5,     6,    -1,    -1,     9,
    -1,   141,    12,   134,   135,   136,   137,    -1,    -1,   140,
    -1,   134,   135,   136,   137,    -1,    -1,   140,   134,   135,
   136,   137,    -1,    -1,   140,    -1,    -1,    -1,    -1,    -1,
    40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    63,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    74,    75,    59,    -1,    -1,     5,
     6,    -1,    -1,     9,    -1,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    -1,    96,    97,    98,    99,
   100,   101,   102,   103,    30,    -1,    -1,   107,   108,    -1,
    -1,    -1,   112,    -1,   114,    -1,    -1,   117,   118,   119,
    -1,    -1,    -1,   123,    -1,   125,   126,   134,   135,   136,
   137,    -1,    -1,   140,   134,    -1,    -1,    63,    -1,    -1,
   140,   141,    -1,     5,     6,    -1,    -1,     9,    74,    75,
    -1,   134,   135,   136,   137,    -1,    -1,   140,    -1,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    -1,
    96,    97,    98,    99,   100,   101,   102,   103,    -1,    -1,
    -1,   107,   108,    -1,    -1,    -1,   112,    -1,   114,    -1,
    -1,   117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,
   126,    63,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,
    -1,    -1,    74,    75,    -1,   141,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    85,    86,    87,    88,    89,    90,    91,
    92,    93,    94,    -1,    96,    97,    98,    99,   100,   101,
   102,   103,    -1,    -1,    -1,   107,   108,    -1,    -1,    -1,
   112,    -1,   114,    -1,    -1,   117,   118,   119,    -1,    -1,
    -1,   123,    -1,   125,   126,    -1,    -1,    -1,    -1,     6,
     7,     8,   134,    59,    11,    -1,    -1,    -1,    15,   141,
    17,    59,    19,    20,    21,    22,    23,    -1,    25,    26,
    27,    28,    29,    -1,    -1,    -1,    33,    -1,    -1,    -1,
    -1,    -1,    39,    40,    41,    42,    43,    44,    45,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    60,    61,    62,    63,    64,    -1,    66,
    67,    68,    69,    70,    -1,    72,    73,    -1,    -1,    76,
    77,    -1,    79,    -1,    81,    82,    83,    -1,   134,   135,
   136,   137,    -1,    -1,   140,    -1,   134,   135,   136,   137,
    -1,    -1,   140,    -1,    -1,    -1,    -1,   104,   105,   106,
    -1,    -1,    -1,   110,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   125,    -1,
    -1,   128
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */


/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

#ifndef YYPARSE_RETURN_TYPE
#define YYPARSE_RETURN_TYPE int
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
YYPARSE_RETURN_TYPE yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

YYPARSE_RETURN_TYPE
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
{end_of_file=TRUE;YYACCEPT;;
    break;}
case 3:
{if (errorlevel<=ERROR) {YYABORT;};
    break;}
case 4:
{yylineno+=yyvsp[0].sep;
	  if (due_to_import) {import_lib(due_to_import);due_to_import=NULL;}
	;
    break;}
case 9:
{due_to_import=my_strdup(yyvsp[0].symbol);;
    break;}
case 10:
{add_command(cERROR,NULL);;
    break;}
case 15:
{create_call(yyvsp[0].symbol);add_command(cPOP,NULL);;
    break;}
case 16:
{create_call(yyvsp[0].symbol);add_command(cPOPSTRSYM,NULL);;
    break;}
case 17:
{if (function_type==ftNONE) error(ERROR,"no use for 'local' outside functions");;
    break;}
case 19:
{if (function_type==ftNONE) error(ERROR,"no use for 'static' outside functions");;
    break;}
case 23:
{create_goto(yyvsp[0].symbol);;
    break;}
case 24:
{create_gosub(yyvsp[0].symbol);;
    break;}
case 25:
{create_exception(TRUE);;
    break;}
case 26:
{create_exception(FALSE);;
    break;}
case 27:
{add_command(cSKIPPER,NULL);;
    break;}
case 28:
{add_command(cNOP,NULL);;
    break;}
case 29:
{add_command(cSKIPPER,NULL);;
    break;}
case 30:
{add_command(cNOP,NULL);;
    break;}
case 31:
{create_label(yyvsp[0].symbol,cLABEL);;
    break;}
case 32:
{add_command(cCHECKOPEN,NULL);;
    break;}
case 33:
{add_command(cCLOSE,NULL);;
    break;}
case 34:
{create_colour(0);create_print('n');;
    break;}
case 35:
{create_colour(0);;
    break;}
case 36:
{create_colour(0);create_print('t');;
    break;}
case 37:
{tileol=FALSE;;
    break;}
case 39:
{tileol=TRUE;;
    break;}
case 43:
{create_restore("");;
    break;}
case 44:
{create_restore(yyvsp[0].symbol);;
    break;}
case 45:
{if (function_type!=ftNONE) {
	       add_command(cPOPSYMLIST,NULL);
               create_retval(ftNONE,function_type);
               add_command(cRET_FROM_FUN,NULL);
            } else {
               add_command(cRETURN,NULL);
            };
    break;}
case 46:
{if (function_type==ftNONE) {error(ERROR,"can not return value"); YYABORT;} add_command(cPOPSYMLIST,NULL);create_retval(ftNUMBER,function_type);add_command(cRET_FROM_FUN,NULL);;
    break;}
case 47:
{if (function_type==ftNONE) {error(ERROR,"can not return value"); YYABORT;} add_command(cPOPSYMLIST,NULL);create_retval(ftSTRING,function_type);add_command(cRET_FROM_FUN,NULL);;
    break;}
case 49:
{create_openwin(FALSE);;
    break;}
case 50:
{create_openwin(TRUE);;
    break;}
case 51:
{add_command(cMOVEORIGIN,NULL);;
    break;}
case 52:
{add_command(cDOT,NULL);;
    break;}
case 53:
{create_line('l');;
    break;}
case 54:
{create_line('t');;
    break;}
case 55:
{add_command(cPUTBIT,NULL);;
    break;}
case 56:
{create_pushstr("replace"); add_command(cPUTBIT,NULL);;
    break;}
case 57:
{add_command(cPUTCHAR,NULL);;
    break;}
case 58:
{create_line('n');;
    break;}
case 59:
{add_command(cCIRCLE,NULL);
    break;}
case 60:
{create_text(FALSE);;
    break;}
case 61:
{create_text(TRUE);;
    break;}
case 62:
{create_rect(3);;
    break;}
case 63:
{create_rect(2);;
    break;}
case 64:
{create_rect(2);;
    break;}
case 65:
{create_rect(1);;
    break;}
case 66:
{create_rect(1);;
    break;}
case 67:
{add_command(cCLOSEWIN,NULL);;
    break;}
case 68:
{add_command(cCLEARWIN,NULL);;
    break;}
case 69:
{add_command(cCLEARSCR,NULL);;
    break;}
case 70:
{create_openprinter(0);;
    break;}
case 71:
{create_openprinter(1);;
    break;}
case 72:
{add_command(cCLOSEPRN,NULL);;
    break;}
case 73:
{add_command(cWAIT,NULL);;
    break;}
case 74:
{add_command(cBELL,NULL);;
    break;}
case 75:
{create_pushdbl(-1);create_function(fINKEY);add_command(cPOPSTRSYM,NULL);;
    break;}
case 76:
{create_pushdbl(-1);create_function(fINKEY);add_command(cPOPSTRSYM,NULL);;
    break;}
case 77:
{create_function(fINKEY);add_command(cPOPSTRSYM,NULL);;
    break;}
case 78:
{create_function(fSYSTEM2);
	add_command(cPOP,NULL);;
    break;}
case 79:
{create_poke('s');;
    break;}
case 80:
{create_poke('d');;
    break;}
case 81:
{create_poke('S');;
    break;}
case 82:
{create_poke('D');;
    break;}
case 83:
{add_command(cEND,NULL);;
    break;}
case 84:
{create_pushdbl(0.);add_command(cEXIT,NULL);;
    break;}
case 85:
{add_command(cEXIT,NULL);;
    break;}
case 86:
{create_docu(yyvsp[0].symbol);;
    break;}
case 87:
{add_command(cPOPSTRSYM,dotify(yyvsp[-2].symbol));;
    break;}
case 88:
{create_changestring(fMID);;
    break;}
case 89:
{create_changestring(fLEFT);;
    break;}
case 90:
{create_changestring(fRIGHT);;
    break;}
case 91:
{create_doarray(dotify(yyvsp[-2].symbol),ASSIGNSTRINGARRAY);;
    break;}
case 94:
{create_myopen(3);;
    break;}
case 95:
{create_myopen(2);;
    break;}
case 96:
{add_command(cPUSHSTRPTR,dotify(yyvsp[0].symbol));;
    break;}
case 97:
{create_doarray(dotify(yyvsp[-3].symbol),GETSTRINGPOINTER);;
    break;}
case 98:
{add_command(cPUSHSTRSYM,dotify(yyvsp[0].symbol));;
    break;}
case 100:
{create_function_or_array(cSTRINGFUNCTION_OR_ARRAY,yyvsp[0].symbol);;
    break;}
case 101:
{if (yyvsp[0].string==NULL) {error(ERROR,"String not terminated");create_pushstr("");} else {create_pushstr(yyvsp[0].string);};
    break;}
case 102:
{add_command(cCONCAT,NULL);;
    break;}
case 104:
{create_function(fLEFT);;
    break;}
case 105:
{create_function(fRIGHT);;
    break;}
case 106:
{create_function(fMID);;
    break;}
case 107:
{create_function(fSTR);;
    break;}
case 108:
{create_function(fSTR2);;
    break;}
case 109:
{create_pushdbl(-1);create_function(fINKEY);;
    break;}
case 110:
{create_pushdbl(-1);create_function(fINKEY);;
    break;}
case 111:
{create_function(fINKEY);;
    break;}
case 112:
{create_function(fCHR);;
    break;}
case 113:
{create_function(fUPPER);;
    break;}
case 114:
{create_function(fLOWER);;
    break;}
case 115:
{create_function(fLTRIM);;
    break;}
case 116:
{create_function(fRTRIM);;
    break;}
case 117:
{create_function(fTRIM);;
    break;}
case 118:
{create_function(fSYSTEM);;
    break;}
case 119:
{create_function(fDATE);;
    break;}
case 120:
{create_function(fTIME);;
    break;}
case 121:
{create_function(fPEEK2);;
    break;}
case 122:
{create_function(fPEEK3);;
    break;}
case 123:
{create_token(2);;
    break;}
case 124:
{create_token(0);;
    break;}
case 125:
{create_token(3);;
    break;}
case 126:
{create_token(1);;
    break;}
case 127:
{create_function(fGETBIT);;
    break;}
case 128:
{create_function(fGETCHAR);;
    break;}
case 129:
{create_function(fHEX);;
    break;}
case 130:
{add_command(cPOPDBLSYM,dotify(yyvsp[-2].symbol));;
    break;}
case 131:
{create_doarray(yyvsp[-2].symbol,ASSIGNARRAY);;
    break;}
case 132:
{create_pushdbl(yyvsp[0].fnum);;
    break;}
case 134:
{add_command(cARDIM,NULL);;
    break;}
case 135:
{add_command(cARDIM,NULL);;
    break;}
case 136:
{add_command(cARSIZE,NULL);;
    break;}
case 137:
{add_command(cARSIZE,NULL);;
    break;}
case 138:
{create_function_or_array(cFUNCTION_OR_ARRAY,yyvsp[0].symbol);;
    break;}
case 140:
{add_command(cPUSHDBLSYM,dotify(yyvsp[0].symbol));;
    break;}
case 141:
{create_dblbin('+');;
    break;}
case 142:
{create_dblbin('-');;
    break;}
case 143:
{create_dblbin('*');;
    break;}
case 144:
{create_dblbin('/');;
    break;}
case 145:
{create_dblbin('^');;
    break;}
case 146:
{add_command(cNEGATE,NULL);;
    break;}
case 148:
{create_function(fSIN);;
    break;}
case 149:
{create_function(fASIN);;
    break;}
case 150:
{create_function(fCOS);;
    break;}
case 151:
{create_function(fACOS);;
    break;}
case 152:
{create_function(fTAN);;
    break;}
case 153:
{create_function(fATAN);;
    break;}
case 154:
{create_function(fATAN2);;
    break;}
case 155:
{create_function(fEXP);;
    break;}
case 156:
{create_function(fLOG);;
    break;}
case 157:
{create_function(fSQRT);;
    break;}
case 158:
{create_function(fSQR);;
    break;}
case 159:
{create_function(fINT);;
    break;}
case 160:
{create_function(fFRAC);;
    break;}
case 161:
{create_function(fABS);;
    break;}
case 162:
{create_function(fSIG);;
    break;}
case 163:
{create_function(fMOD);;
    break;}
case 164:
{create_function(fRAN);;
    break;}
case 165:
{create_function(fRAN2);;
    break;}
case 166:
{create_function(fMIN);;
    break;}
case 167:
{create_function(fMAX);;
    break;}
case 168:
{create_function(fLEN);;
    break;}
case 169:
{create_function(fVAL);;
    break;}
case 170:
{create_function(fASC);;
    break;}
case 171:
{create_function(fDEC);;
    break;}
case 172:
{create_function(fINSTR);;
    break;}
case 173:
{create_function(fSYSTEM2);;
    break;}
case 174:
{create_function(fPEEK4);;
    break;}
case 175:
{create_function(fPEEK);;
    break;}
case 176:
{create_function(fMOUSEX);;
    break;}
case 177:
{create_pushstr("");create_function(fMOUSEX);;
    break;}
case 178:
{create_function(fMOUSEY);;
    break;}
case 179:
{create_pushstr("");create_function(fMOUSEY);;
    break;}
case 180:
{create_function(fMOUSEB);;
    break;}
case 181:
{create_pushstr("");create_function(fMOUSEB);;
    break;}
case 182:
{create_myopen(-1);;
    break;}
case 183:
{create_myopen(-2);;
    break;}
case 184:
{yyval.fnum=yyvsp[0].fnum;;
    break;}
case 185:
{yyval.fnum=yyvsp[0].fnum;;
    break;}
case 186:
{yyval.fnum=-yyvsp[0].fnum;;
    break;}
case 187:
{yyval.fnum=yyvsp[0].fnum;;
    break;}
case 188:
{yyval.fnum=atoi(yyvsp[0].digits);;
    break;}
case 189:
{yyval.symbol=my_strdup(dotify(yyvsp[0].digits));;
    break;}
case 190:
{yyval.symbol=my_strdup(dotify(yyvsp[0].symbol));;
    break;}
case 191:
{create_dim(dotify(yyvsp[-3].symbol),'d');;
    break;}
case 192:
{create_dim(dotify(yyvsp[-3].symbol),'d');;
    break;}
case 193:
{create_dim(dotify(yyvsp[-3].symbol),'s');;
    break;}
case 194:
{create_dim(dotify(yyvsp[-3].symbol),'s');;
    break;}
case 195:
{yyval.symbol=my_strdup(dotify(yyvsp[-3].symbol));;
    break;}
case 196:
{yyval.symbol=my_strdup(dotify(yyvsp[-3].symbol));;
    break;}
case 197:
{add_command(cPUSHFREE,NULL);;
    break;}
case 204:
{pushlabel();if (function_type!=ftNONE) {error(ERROR,"nested functions not allowed");YYABORT;};
    break;}
case 205:
{if (exported) create_sublink(yyvsp[0].symbol); create_label(yyvsp[0].symbol,cUSER_FUNCTION);
	               add_command(cPUSHSYMLIST,NULL);add_command(cNUMPARAM,NULL);;
    break;}
case 206:
{create_require(stFREE);add_command(cPOP,NULL);;
    break;}
case 207:
{add_command(cPOPSYMLIST,NULL);create_retval(ftNONE,function_type);function_type=ftNONE;add_command(cRET_FROM_FUN,NULL);create_endfunction();poplabel();;
    break;}
case 208:
{function_type=ftNUMBER;current_function=my_strdup(dotify(yyvsp[0].symbol));yyval.symbol=my_strdup(dotify(yyvsp[0].symbol));;
    break;}
case 209:
{function_type=ftSTRING;current_function=my_strdup(dotify(yyvsp[0].symbol));yyval.symbol=my_strdup(dotify(yyvsp[0].symbol));;
    break;}
case 210:
{exported=FALSE;;
    break;}
case 211:
{exported=TRUE;;
    break;}
case 214:
{create_makelocal(dotify(yyvsp[0].symbol),syNUMBER);;
    break;}
case 215:
{create_makelocal(dotify(yyvsp[0].symbol),sySTRING);;
    break;}
case 216:
{create_makelocal(dotify(yyvsp[-3].symbol),syARRAY);create_dim(dotify(yyvsp[-3].symbol),'d');;
    break;}
case 217:
{create_makelocal(dotify(yyvsp[-3].symbol),syARRAY);create_dim(dotify(yyvsp[-3].symbol),'s');;
    break;}
case 220:
{create_makestatic(dotify(yyvsp[0].symbol),syNUMBER);;
    break;}
case 221:
{create_makestatic(dotify(yyvsp[0].symbol),sySTRING);;
    break;}
case 222:
{create_makestatic(dotify(yyvsp[-3].symbol),syARRAY);create_dim(dotify(yyvsp[-3].symbol),'d');;
    break;}
case 223:
{create_makestatic(dotify(yyvsp[-3].symbol),syARRAY);create_dim(dotify(yyvsp[-3].symbol),'s');;
    break;}
case 227:
{create_require(stNUMBER);create_makelocal(dotify(yyvsp[0].symbol),syNUMBER);add_command(cPOPDBLSYM,dotify(yyvsp[0].symbol));;
    break;}
case 228:
{create_require(stSTRING);create_makelocal(dotify(yyvsp[0].symbol),sySTRING);add_command(cPOPSTRSYM,dotify(yyvsp[0].symbol));;
    break;}
case 229:
{create_require(stNUMBERARRAYREF);create_arraylink(dotify(yyvsp[-2].symbol),stNUMBERARRAYREF);;
    break;}
case 230:
{create_require(stSTRINGARRAYREF);create_arraylink(dotify(yyvsp[-2].symbol),stSTRINGARRAYREF);;
    break;}
case 231:
{pushname(dotify(yyvsp[-1].symbol)); /* will be used by next_symbol to check equality */
	     add_command(cRESETSKIPONCE,NULL);
	     pushgoto();;
    break;}
case 232:
{ /* pushes another expression */
	     add_command(cSKIPONCE,NULL);
	     pushlabel();
	     add_command(cSTARTFOR,NULL);
	     add_command(cPOPDBLSYM,dotify(yyvsp[-6].symbol));
	     poplabel();
	     add_command(cPUSHDBLSYM,dotify(yyvsp[-6].symbol));
	     add_command(cFORINCREMENT,NULL);
	     add_command(cPOPDBLSYM,dotify(yyvsp[-6].symbol));
	     add_command(cPUSHDBLSYM,dotify(yyvsp[-6].symbol));
	     add_command(cFORCHECK,NULL);
	     add_command(cDECIDE,NULL);
             pushlabel();;
    break;}
case 233:
{yylineno+=yyvsp[0].sep;;
    break;}
case 234:
{
             swap();popgoto();poplabel();;
    break;}
case 237:
{end_of_file=TRUE;
	    error(ERROR,"'next' statement is missing"); YYABORT;;
    break;}
case 238:
{create_pushdbl(1.0);;
    break;}
case 240:
{pop(stSTRING);;
    break;}
case 241:
{if (strcmp(pop(stSTRING)->pointer,dotify(yyvsp[0].symbol))) 
             {error(ERROR,"'for' and 'next' do not match"); YYABORT;}
           ;
    break;}
case 242:
{pushgoto();
    break;}
case 243:
{add_command(cDECIDE,NULL);
	      pushlabel();;
    break;}
case 244:
{swap();popgoto();poplabel();;
    break;}
case 245:
{pushgoto();;
    break;}
case 246:
{add_command(cDECIDE,NULL);popgoto();;
    break;}
case 247:
{add_command(cDECIDE,NULL);storelabel();pushlabel();;
    break;}
case 248:
{swap();matchgoto();swap();poplabel();;
    break;}
case 249:
{poplabel();;
    break;}
case 251:
{add_command(cDECIDE,NULL);pushlabel();;
    break;}
case 252:
{poplabel();;
    break;}
case 254:
{end_of_file=TRUE;
            error(ERROR,"'endif'-statement is missing"); YYABORT;;
    break;}
case 256:
{create_boole('|');;
    break;}
case 257:
{create_boole('&');;
    break;}
case 258:
{create_boole('!');;
    break;}
case 259:
{create_strrelop('=');;
    break;}
case 260:
{create_strrelop('!');;
    break;}
case 261:
{create_strrelop('<');;
    break;}
case 262:
{create_strrelop('{');;
    break;}
case 263:
{create_strrelop('>');;
    break;}
case 264:
{create_strrelop('}');;
    break;}
case 265:
{create_dblrelop('=');;
    break;}
case 266:
{create_dblrelop('!');;
    break;}
case 267:
{create_dblrelop('<');;
    break;}
case 268:
{create_dblrelop('{');;
    break;}
case 269:
{create_dblrelop('>');;
    break;}
case 270:
{create_dblrelop('}');;
    break;}
case 271:
{add_command(cTESTEOF,NULL);;
    break;}
case 272:
{add_command(cGLOB,NULL);;
    break;}
case 277:
{add_command(cDECIDE,NULL);pushlabel();;
    break;}
case 278:
{swap();matchgoto();swap();poplabel();;
    break;}
case 281:
{add_command(cCHKPROMPT,NULL);;
    break;}
case 283:
{create_myread('d',tileol);add_command(cPOPDBLSYM,dotify(yyvsp[0].symbol));;
    break;}
case 284:
{create_myread('d',tileol);create_doarray(dotify(yyvsp[-3].symbol),ASSIGNARRAY);;
    break;}
case 285:
{create_myread('s',tileol);add_command(cPOPSTRSYM,dotify(yyvsp[0].symbol));;
    break;}
case 286:
{create_myread('s',tileol);create_doarray(dotify(yyvsp[-3].symbol),ASSIGNSTRINGARRAY);;
    break;}
case 289:
{create_readdata('d');add_command(cPOPDBLSYM,dotify(yyvsp[0].symbol));;
    break;}
case 290:
{create_readdata('d');create_doarray(dotify(yyvsp[-3].symbol),ASSIGNARRAY);;
    break;}
case 291:
{create_readdata('s');add_command(cPOPSTRSYM,dotify(yyvsp[0].symbol));;
    break;}
case 292:
{create_readdata('s');create_doarray(dotify(yyvsp[-3].symbol),ASSIGNSTRINGARRAY);;
    break;}
case 293:
{create_strdata(yyvsp[0].string);;
    break;}
case 294:
{create_dbldata(yyvsp[0].fnum);;
    break;}
case 295:
{create_strdata(yyvsp[0].string);;
    break;}
case 296:
{create_dbldata(yyvsp[0].fnum);;
    break;}
case 300:
{create_print('s');;
    break;}
case 301:
{create_print('s');;
    break;}
case 302:
{create_print('d');;
    break;}
case 303:
{create_print('u');;
    break;}
case 304:
{create_myswitch(-1);;
    break;}
case 306:
{create_myswitch(0);;
    break;}
case 308:
{create_pushstr("?");create_print('s');;
    break;}
case 309:
{create_pushstr(yyvsp[0].string);create_print('s');;
    break;}
case 310:
{create_myswitch(-1);;
    break;}
case 311:
{create_myswitch(0);;
    break;}
case 312:
{create_colour(1);create_myswitch(0);;
    break;}
case 313:
{create_colour(2);create_myswitch(0);;
    break;}
case 314:
{create_colour(3);create_myswitch(0);;
    break;}
case 316:
{add_command(cMOVE,NULL);;
    break;}
case 321:
{create_pushdbl(atoi(yyvsp[0].digits));;
    break;}
case 322:
{create_goto(yyvsp[0].symbol);add_command(cFINDNOP,NULL);;
    break;}
case 323:
{create_goto(yyvsp[0].symbol);add_command(cFINDNOP,NULL);;
    break;}
case 324:
{create_gosub(yyvsp[0].symbol);add_command(cFINDNOP,NULL);;
    break;}
case 325:
{create_gosub(yyvsp[0].symbol);add_command(cFINDNOP,NULL);;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */


  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
