typedef union {
  double fnum;          /* double number */
  int inum;             /* integer number */
  int token;            /* token of command */
  int sep;              /* number of newlines */
  char *string;         /* quoted string */
  char *symbol;         /* general symbol */
  char *digits;         /* string of digits */
  char *docu;		/* embedded documentation */
} YYSTYPE;
#define	tSEP	258
#define	tEOFILE	259
#define	tFNUM	260
#define	tSYMBOL	261
#define	tSTRSYM	262
#define	tDOCU	263
#define	tDIGITS	264
#define	tSTRING	265
#define	tFOR	266
#define	tTO	267
#define	tSTEP	268
#define	tNEXT	269
#define	tWHILE	270
#define	tWEND	271
#define	tREPEAT	272
#define	tUNTIL	273
#define	tGOTO	274
#define	tGOSUB	275
#define	tLABEL	276
#define	tON	277
#define	tSUB	278
#define	tENDSUB	279
#define	tLOCAL	280
#define	tSTATIC	281
#define	tIMPORT	282
#define	tEXPORT	283
#define	tERROR	284
#define	tINTERRUPT	285
#define	tBREAK	286
#define	tCONTINUE	287
#define	tIF	288
#define	tTHEN	289
#define	tELSE	290
#define	tELSIF	291
#define	tENDIF	292
#define	tUSING	293
#define	tPRINT	294
#define	tINPUT	295
#define	tLINE	296
#define	tRETURN	297
#define	tDIM	298
#define	tEND	299
#define	tEXIT	300
#define	tAT	301
#define	tSCREEN	302
#define	tREVERSE	303
#define	tCOLOUR	304
#define	tAND	305
#define	tOR	306
#define	tNOT	307
#define	tNEQ	308
#define	tLEQ	309
#define	tGEQ	310
#define	tLTN	311
#define	tGTN	312
#define	tEQU	313
#define	tPOW	314
#define	tREAD	315
#define	tDATA	316
#define	tRESTORE	317
#define	tOPEN	318
#define	tCLOSE	319
#define	tORIGIN	320
#define	tWINDOW	321
#define	tDOT	322
#define	tCIRCLE	323
#define	tTEXT	324
#define	tCLEAR	325
#define	tPRINTER	326
#define	tWAIT	327
#define	tBELL	328
#define	tARDIM	329
#define	tARSIZE	330
#define	tBOX	331
#define	tRECT	332
#define	tGETBIT	333
#define	tPUTBIT	334
#define	tGETCHAR	335
#define	tPUTCHAR	336
#define	tFRAME	337
#define	tNEW	338
#define	tCURVE	339
#define	tSIN	340
#define	tASIN	341
#define	tCOS	342
#define	tACOS	343
#define	tTAN	344
#define	tATAN	345
#define	tEXP	346
#define	tLOG	347
#define	tSQRT	348
#define	tSQR	349
#define	tMYEOF	350
#define	tABS	351
#define	tSIG	352
#define	tINT	353
#define	tFRAC	354
#define	tMOD	355
#define	tRAN	356
#define	tLEN	357
#define	tVAL	358
#define	tLEFT	359
#define	tRIGHT	360
#define	tMID	361
#define	tMIN	362
#define	tMAX	363
#define	tSTR	364
#define	tINKEY	365
#define	tCHR	366
#define	tASC	367
#define	tHEX	368
#define	tDEC	369
#define	tUPPER	370
#define	tLOWER	371
#define	tMOUSEX	372
#define	tMOUSEY	373
#define	tMOUSEB	374
#define	tTRIM	375
#define	tLTRIM	376
#define	tRTRIM	377
#define	tINSTR	378
#define	tSYSTEM	379
#define	tSYSTEM2	380
#define	tPEEK	381
#define	tPEEK2	382
#define	tPOKE	383
#define	tDATE	384
#define	tTIME	385
#define	tTOKEN	386
#define	tSPLIT	387
#define	tGLOB	388
#define	UMINUS	389


extern YYSTYPE yylval;
